' 

    %usemacros = 1

    #RESOURCE "project.pbr"

  ' Comment out exclusion for required control

    ' %NOSTATUSBAR       = 1
    ' %NOTOOLBAR         = 1
    ' %NOREBAR           = 1  ' Rebar control
'  --- Graphics: ---
'   %NOGDI = 1     ' no GDI (Graphics Device Interface) functions
'  --- Multimedia: ---
    %NOMMIDS           = 1  ' no Multimedia ID definitions
    %NONEWWAVE         = 1  ' no new waveform types except WAVEFORMATEX are defined
    %NONEWRIFF         = 1  ' no new RIFF formats are defined
    %NOJPEGDIB         = 1  ' no JPEG DIB definitions
    %NONEWIC           = 1  ' no new Image Compressor types are defined
    %NOBITMAP          = 1  ' no extended bitmap info header definition
    %NOANIMATE         = 1  ' Animate control
    %NOBUTTON          = 1  ' Button
    %NOCOMBO           = 1  ' Combo box
    %NOCOMBOEX         = 1  ' ComboBoxEx
    %NODATETIMEPICK    = 1  ' Date/time picker
    %NODRAGLIST        = 1  ' Drag list control
    %NOEDIT            = 1  ' Edit control
    %NOFLATSBAPIS      = 1  ' Flat scroll bar
    %NOHEADER          = 1  ' Header control
    %NOHOTKEY          = 1  ' HotKey control
    %NOIMAGELIST       = 1  ' Image APIs
    %NOIPADDRESS       = 1  ' IP Address edit control
    %NOLIST            = 1  ' List box control
    %NOLISTVIEW        = 1  ' ListView control
    %NOMENUHELP        = 1  ' Menu help
    %NOMONTHCAL        = 1  ' MonthCal
    %NOMUI             = 1  ' MUI
    %NONATIVEFONTCTL   = 1  ' Native Font control
    %NOPAGESCROLLER    = 1  ' Pager
    %NOPROGRESS        = 1  ' Progress control
    %NOTABCONTROL      = 1  ' Tab control
    %NOTOOLTIPS        = 1  ' Tool tips
    %NOTRACKBAR        = 1  ' Track bar
    %NOTRACKMOUSEEVENT = 1  ' Track Mouse Event
    %NOTREEVIEW        = 1  ' TreeView
    %NOUPDOWN          = 1  ' Up Down arrow control
    %NOPRINTDLG        = 1
    %NOFILEDLG         = 1  ' exclude the common dialog file version

  ' --------------------
  ' system include files
  ' --------------------
    #include once "H:\basic_edit\include\win32api.inc"
    #include once "H:\basic_edit\include\comdlg32.inc"
    #include once "H:\basic_edit\include\commctrl.inc"

' 

  ' MACROS used locally in this application

    MACRO CmpKey(vk_key)
      GetAsyncKeyState vk_key
      ! and eax, &B00000000000000001000000000000000
      ! rol eax, 17
      ! cmp eax, 1
    END MACRO

#IF 0  ' ***********************************************

        macro to test if a virtual key is pressed
        use the following ASM instructions to respond

      ' either
        CmpKey(%VK_SHIFT)
        ! je label          ' if VK_SHIFT is pressed

      ' or
        CmpKey(%VK_SHIFT)
        ! jne label         ' if VK_SHIFT is not pressed

      ' .......
      label:

#ENDIF ' ***********************************************

  ' -------------------
  ' fixed memory macros
  ' -------------------
    MACRO FUNCTION malloc(bcnt) = GlobalAlloc(%GMEM_FIXED or %GMEM_ZEROINIT,bcnt)
    MACRO FUNCTION mrealloc(hMem,bcnt) = GlobalReAlloc(hMem,bcnt,%GMEM_MOVEABLE or %GMEM_ZEROINIT)
    MACRO FUNCTION mfree(hMem) = GlobalFree(hMem)

' 

    TYPE MSGSTRUCT
      hwnd      as DWORD
      message   as DWORD
      wParam    as LONG
      lParam    as LONG
      time      as DWORD
      pt        as POINT
    END TYPE

    GLOBAL hInstance   as DWORD
    GLOBAL hIcon       as DWORD
    GLOBAL Sw          as DWORD
    GLOBAL Sh          as DWORD

    GLOBAL hWnd        as DWORD
    GLOBAL hStatus     as DWORD
    GLOBAL hToolBar    as DWORD
    GLOBAL hMnu        as DWORD
    GLOBAL hClient     as DWORD
    GLOBAL hRebar      as DWORD
    GLOBAL hBitmap     as DWORD
    GLOBAL rebarhgt    as DWORD
    GLOBAL tbTile      as DWORD
    GLOBAL tbbtnW      as DWORD
    GLOBAL tbbtnH      as DWORD
    GLOBAL vpadding    as WORD
    GLOBAL hpadding    as WORD
    GLOBAL ClientColour as DWORD

    GLOBAL DisplayName$
    GLOBAL ffilter$                                     ' file dialog filter string

' 


  ' -------------------
  ' local include files
  ' -------------------
    #include once "filedlgs.bas"
    #include once "toolbar.bas"
    #include once "misc.bas"

