' 

    MACRO AddButton(bmID,cmdID)
      tbb.iBitmap   =  bmID  ' button  ID number
      tbb.idCommand =  cmdID ' command ID number
      tbb.fsStyle   = %TBSTYLE_BUTTON  or %TBSTYLE_AUTOSIZE
      SendMessage tbHndl,%TB_ADDBUTTONS,1,ByVal VarPtr(tbb)
    END MACRO

    MACRO TxtRadio(bmID,cmdID)
      tbb.iBitmap   =  bmID
      tbb.idCommand =  cmdID ' command ID number
      tbb.fsStyle   =  %BTNS_AUTOSIZE or %BTNS_CHECKGROUP
      SendMessage tbHndl,%TB_ADDBUTTONS,1,ByVal VarPtr(tbb)
    END MACRO

    MACRO Seperator
      tbb.iBitmap   = -1
      tbb.idCommand = -1
      tbb.fsStyle   = %TBSTYLE_SEP
      SendMessage tbHndl,%TB_ADDBUTTONS,1,ByVal VarPtr(tbb)
    END MACRO

' 

FUNCTION rebar(ByVal iinstance as DWORD,ByVal hParent as DWORD) as DWORD

    LOCAL hrbar as DWORD

    hrbar = CreateWindowEx(%WS_EX_LEFT,"ReBarWindow32",ByVal %NULL, _
                           %WS_VISIBLE or %WS_CHILD or _
                           %WS_CLIPCHILDREN or %WS_CLIPSIBLINGS or _
                           %RBS_VARHEIGHT or %CCS_NOPARENTALIGN or %CCS_NODIVIDER, _
                           0,0,1024,rebarhgt,hParent,ByVal %NULL,iinstance,ByVal %NULL)

    ShowWindow hrbar,%SW_SHOW
    UpdateWindow hrbar

    FUNCTION = hrbar

END FUNCTION

' 

SUB addband(ByVal iinstance as DWORD,ByVal hrbar as DWORD)

    LOCAL rbbi  as REBARBANDINFO

    hToolbar = Create_Tool_Bar(iinstance,hrbar,tbbtnW,tbbtnH)

    rbbi.cbSize     = sizeof(REBARBANDINFO)
    rbbi.fMask      = %RBBIM_ID or %RBBIM_STYLE or _
                      %RBBIM_BACKGROUND or %RBBIM_CHILDSIZE or %RBBIM_CHILD
    rbbi.wID        = 125
    rbbi.fStyle     = %RBBS_FIXEDBMP    ' RBBS_CHILDEDGE or RBBS_NOGRIPPER or RBBS_GRIPPERALWAYS
    rbbi.hbmBack    = tbTile
    rbbi.cxMinChild = 0
    rbbi.cyMinChild = rebarhgt
    rbbi.hwndChild  = hToolBar

    SendMessage hrbar,%RB_INSERTBAND,0,ByVal VarPtr(rbbi)

END SUB

' 

FUNCTION Create_Tool_Bar(ByVal iinstance as DWORD,ByVal hParent as DWORD, _
                         ByVal bmW as DWORD,ByVal bmH as DWORD) as DWORD
    #REGISTER NONE

    LOCAL tbHndl  as DWORD
    LOCAL bSize   as DWORD
    LOCAL padd    as DWORD
    LOCAL tbab    as TBADDBITMAP
    LOCAL tbb     as TBBUTTON

    tbHndl = CreateWindowEx(0, _
             "ToolbarWindow32", _
             ByVal %NULL, _
             %WS_CHILD or %WS_VISIBLE or %TBSTYLE_FLAT or _
             %TBSTYLE_TRANSPARENT or %CCS_NODIVIDER, _
             0,0,500,rebarhgt, _
             hParent,ByVal %NULL, _
             iinstance,ByVal %NULL)

  ' ------------------------------------------------------------------
  ' set vertical and horizontal padding for buttons (units are pixels)
  ' ------------------------------------------------------------------
    ! mov ax, vpadding  ; vertical padding
    ! rol eax, 16
    ! mov ax, hpadding  ; horizontal padding
    ! mov padd, eax

    SendMessage tbHndl,%TB_SETPADDING,0,padd

  ' --------------------------------------------------------
  ' set left side indent for first button (units are pixels)
  ' --------------------------------------------------------
    SendMessage tbHndl,%TB_SETINDENT,5,0

    SendMessage tbHndl,%TB_BUTTONSTRUCTSIZE,sizeof(tbb),0

  ' -----------------------------------
  ' set the bitmap size for each button
  ' -----------------------------------
    ! mov ax, bmH       ; bitmap height
    ! rol eax, 16       ; rotate register by 16 bits
    ! mov ax, bmW       ; bitmap width
    ! mov bSize, eax

    SendMessage tbHndl,%TB_SETBITMAPSIZE,0,bSize

    tbab.hInst = 0
    tbab.nID   = hBitmap

    SendMessage tbHndl,%TB_ADDBITMAP,16,ByVal VarPtr(tbab)
    
    SendMessage tbHndl,%TB_SETBUTTONSIZE,0,bSize

    tbb.fsState   = %TBSTATE_ENABLED
    tbb.dwData    = 0
    tbb.iString   = 0

  ' -----------------------------------------------------------
  ' AddButton MACRO
  ' Parameters are zero based index for toolbar button bitmap
  ' and control ID for WM_COMMAND processing in the WndProc()
  ' -----------------------------------------------------------
    AddButton(0,50)
    AddButton(1,51)
    AddButton(2,52)
    Seperator
    AddButton(3,53)
    AddButton(4,54)
    AddButton(5,55)
    Seperator
    AddButton(6,56)
    AddButton(7,57)
    AddButton(8,58)

    FUNCTION = tbHndl

END FUNCTION

' 

FUNCTION Create_Status_Bar(hParent as DWORD) as DWORD

    LOCAL hndl as DWORD
    dim sbParts(3) as LONG

    hndl = CreateStatusWindow(%WS_CHILD or %WS_VISIBLE or _
                              %SBS_SIZEGRIP,ByVal %NULL,hParent, 200)

    sbParts(0) =  150
    sbParts(1) =  300
    sbParts(2) =  450
    sbParts(3) = -1

    SendMessage hndl,%SB_SETPARTS, 4,ByVal VarPtr(sbParts(0))

    FUNCTION = hndl

END FUNCTION

' 
